<?php if (!defined('ABSPATH')) {
    exit;
}
// Exit if accessed directly

if (!class_exists('MM_POST_TYPES')) {

    /**
     * Model that houses the logic of MM Custom Post Types.
     *
     * @since 1.0.0
     */
    class MM_POST_TYPES {

        /*
        |--------------------------------------------------------------------------
        | Class Properties
        |--------------------------------------------------------------------------
         */

    

        /*
        |--------------------------------------------------------------------------
        | Class Methods
        |--------------------------------------------------------------------------
         */




        /**
         * Initialize Post Types.
         *
         * @since 1.0.0
         * @access public
         */
        public function mm_post_type_init() {

        	//Indirect Tax Type (mm-indirect-tax-type) ***********************************************************************
        	$labels = array(
        		'name'               => _x( 'Indirect Tax Type', 'post type general name',  'managemore-connector' ),
        		'singular_name'      => _x( 'Indirect Tax Type', 'post type singular name',  'managemore-connector' ),
        		'menu_name'          => _x( 'Indirect Tax Types', 'admin menu',  'managemore-connector' ),
        		'name_admin_bar'     => _x( 'Indirect Tax Type', 'add new on admin bar',  'managemore-connector' ),
        		'add_new'            => _x( 'Add New', 'Indirect Tax Type',  'managemore-connector' ),
        		'add_new_item'       => __( 'Add New Indirect Tax Type',  'managemore-connector' ),
        		'new_item'           => __( 'New Indirect Tax Type',  'managemore-connector' ),
        		'edit_item'          => __( 'Edit Indirect Tax Type',  'managemore-connector' ),
        		'view_item'          => __( 'View Indirect Tax Type',  'managemore-connector' ),
        		'all_items'          => __( 'All Indirect Tax Types',  'managemore-connector' ),
        		'search_items'       => __( 'Search Indirect Tax Types',  'managemore-connector' ),
        		'parent_item_colon'  => __( 'Parent Indirect Tax Type:',  'managemore-connector' ),
        		'not_found'          => __( 'No Indirect Tax Type found.',  'managemore-connector' ),
        		'not_found_in_trash' => __( 'No Indirect Tax Types found in Trash.',  'managemore-connector' )
        	);

        	$args = array(
        		'labels'             => $labels,
            'description'        => __( 'Indirect Tax Type',  'managemore-connector' ),
        		'public'             => false,
        		'publicly_queryable' => false,
        		'show_ui'            => true,
        		'show_in_menu'       => false, 
        		'show_in_admin_bar'  => true,
        		'query_var'          => true,
        		'rewrite'            => array( 'slug' => 'indirect-tax-type' ),
        		'capability_type'    => 'post',
        		'has_archive'        => false,
        		'hierarchical'       => false,
        		'supports'           => array( 'title')
        	);

        	register_post_type( 'mm-indirect-tax-type', $args );

//Indirect Tax Post Type deprecated 2.1.0 - We now use a custom database file        	
        	//Indirect Tax (mm-indirect-tax) ***********************************************************************
/*        	$labels = array(
        		'name'               => _x( 'Indirect Tax Rules', 'post type general name',  'managemore-connector' ),
        		'singular_name'      => _x( 'Indirect Tax Rule', 'post type singular name',  'managemore-connector' ),
        		'menu_name'          => _x( 'Indirect Tax Rules', 'admin menu',  'managemore-connector' ),
        		'name_admin_bar'     => _x( 'Indirect Tax Rule', 'add new on admin bar',  'managemore-connector' ),
        		'add_new'            => _x( 'Add New', 'Indirect Tax Rule',  'managemore-connector' ),
        		'add_new_item'       => __( 'Add New Indirect Tax Rule',  'managemore-connector' ),
        		'new_item'           => __( 'New Indirect Tax Rule',  'managemore-connector' ),
        		'edit_item'          => __( 'Edit Indirect Tax Rule',  'managemore-connector' ),
        		'view_item'          => __( 'View Indirect Tax Rule',  'managemore-connector' ),
        		'all_items'          => __( 'All Indirect Tax Rules',  'managemore-connector' ),
        		'search_items'       => __( 'Search Indirect Tax Rules',  'managemore-connector' ),
        		'parent_item_colon'  => __( 'Parent Indirect Tax Rule:',  'managemore-connector' ),
        		'not_found'          => __( 'No Indirect Tax Rule found.',  'managemore-connector' ),
        		'not_found_in_trash' => __( 'No Indirect Tax Rules found in Trash.',  'managemore-connector' )
        	);

        	$args = array(
        		'labels'             => $labels,
            'description'        => __( 'Indirect Tax Rule',  'managemore-connector' ),
        		'public'             => false,
        		'publicly_queryable' => false,
        		'show_ui'            => true,
        		'show_in_menu'       => false, 
        		'show_in_admin_bar'  => true,
        		'query_var'          => true,
        		'rewrite'            => array( 'slug' => 'indirect-tax' ),
        		'capability_type'    => 'post',
        		'has_archive'        => false,
        		'hierarchical'       => false,
        		'supports'           => array ('')
        	);

        	register_post_type( 'mm-indirect-tax', $args );
*/


//Customer Prices Post Type deprecated 2.0.0 - We now use a custom database file        	
/*        	//Customer Price (mm-customer-price) ***********************************************************************
        	$labels = array(
        		'name'               => _x( 'Customer Prices', 'post type general name',  'managemore-connector' ),
        		'singular_name'      => _x( 'Customer Price', 'post type singular name',  'managemore-connector' ),
        		'menu_name'          => _x( 'Customer Prices', 'admin menu',  'managemore-connector' ),
        		'name_admin_bar'     => _x( 'Customer Price', 'add new on admin bar',  'managemore-connector' ),
        		'add_new'            => _x( 'Add New', 'Customer Price',  'managemore-connector' ),
        		'add_new_item'       => __( 'Add New Customer Price',  'managemore-connector' ),
        		'new_item'           => __( 'New Customer Price',  'managemore-connector' ),
        		'edit_item'          => __( 'Edit Customer Price',  'managemore-connector' ),
        		'view_item'          => __( 'View Customer Price',  'managemore-connector' ),
        		'all_items'          => __( 'All Customer Prices',  'managemore-connector' ),
        		'search_items'       => __( 'Search Customer Prices',  'managemore-connector' ),
        		'parent_item_colon'  => __( 'Parent Customer Price:',  'managemore-connector' ),
        		'not_found'          => __( 'No Customer Price found.',  'managemore-connector' ),
        		'not_found_in_trash' => __( 'No Customer Prices found in Trash.',  'managemore-connector' )
        	);

        	$args = array(
        		'labels'             => $labels,
            'description'        => __( 'Customer Price',  'managemore-connector' ),
        		'public'             => false,
        		'publicly_queryable' => false,
        		'show_ui'            => true,
        		'show_in_menu'       => false, 
        		'show_in_admin_bar'  => false,
        		'query_var'          => false,
        		'rewrite'            => array( 'slug' => 'customer-price' ),
        		'capability_type'    => 'post',
        		'has_archive'        => false,
        		'hierarchical'       => false,
        		'supports'           => array (''),
        		'capabilities'       => array(
                                      'create_posts' => 'do_not_allow',
                                      'delete_posts' => 'delete_posts'                                      
                                    )
        	);

        	register_post_type( 'mm-customer-price', $args );
*/
       	
        }


        /**
         * Add Meta Box(es) to Custom Post Types.
         *
         * @since 1.0.0
         * @access public
         */
/*        public function mm_post_type_admin_init(){

           add_meta_box('indirect-tax-meta', 'Indirect Tax Info', array($this,'mm_indirect_tax_meta'), 'mm-indirect-tax', 'normal', 'high');

        }
*/



        /**
         * Add Meta Box for Indirect Tax.
         *
         * @since 1.0.0
         * @access public
         */
/*        public function mm_indirect_tax_meta(){
           global $post;
           $custom = get_post_custom($post->ID);
           $indirect_tax_state =  $custom["mm_indirect_tax_state"][0];
           $indirect_tax_rate =  $custom["mm_indirect_tax_rate"][0];
           $indirect_tax_type = $custom["mm_indirect_tax_type"][0];
           $mm_indirect_tax_calc_method = $custom["mm_indirect_tax_calc_method"][0];
           if ($mm_indirect_tax_calc_method < 1 ){
           	  $mm_indirect_tax_calc_method=1;
           }
           $mm_indirect_tax_calc_method_selected=array(
             $mm_indirect_tax_calc_method => 'selected = "selected"',
             );
           ?>
           <label>Tax Type:</label>
           <select name="mm_indirect_tax_type"> 
           <?php  echo MM_Connector_Functions::post_type_selection_options('mm-indirect-tax-type',$indirect_tax_type);  ?>
           </select>
           <br>
           <br>
           <label>Tax State:</label>
           <input type="text" style="text-transform: uppercase;" maxlength="3" size="3" name="mm_indirect_tax_state" value="<?php echo $indirect_tax_state; ?>"/>
           <br>
           <br>
           <label>Tax Rate:</label>
           <input type="number" min="0" max="1000" step=".0001" name="mm_indirect_tax_rate" value="<?php echo $indirect_tax_rate ?>">
           <br>
           <br>
           <label>Tax Calculation Method:</label>
           <select name="mm_indirect_tax_calc_method">
           	  <option value="1" <?php echo $mm_indirect_tax_calc_method_selected[1]; ?>>Percent of Cost</option>
           	  <option value="2" <?php echo $mm_indirect_tax_calc_method_selected[2]; ?>>Flat Rate</option>
           	  <option value="3" <?php echo $mm_indirect_tax_calc_method_selected[3]; ?>>Net Weight</option>
           	  <option value="4" <?php echo $mm_indirect_tax_calc_method_selected[4]; ?>>Unit 1 Basis</option>
           	  <option value="5" <?php echo $mm_indirect_tax_calc_method_selected[5]; ?>>Unit 2 Basis</option>
           	  <option value="6" <?php echo $mm_indirect_tax_calc_method_selected[6]; ?>>Unit 3 Basis</option>
           	  <option value="10" <?php echo $mm_indirect_tax_calc_method_selected[10]; ?>>Percent of Price</option>
           </select>
           <?php
        }
*/


        /**
         * Save Meta Fields for Custom Post Types.
         *
         * @since 1.0.0
         * @access public
         */
// No Longer needed 2.1.0 - Indirect Tax Rules post type was removed
/*        public function mm_post_type_save_details(){
        	global $post;
        	switch ($post->post_type){
        		//Indirect Taxes ********************************************************************
        		case 'mm-indirect-tax':
               update_post_meta($post->ID, "mm_indirect_tax_type", $_POST["mm_indirect_tax_type"]);
               update_post_meta($post->ID, "mm_indirect_tax_state", sanitize_text_field(strtoupper($_POST["mm_indirect_tax_state"])));
               update_post_meta($post->ID, "mm_indirect_tax_rate", $_POST["mm_indirect_tax_rate"]);
               update_post_meta($post->ID, "mm_indirect_tax_calc_method", $_POST["mm_indirect_tax_calc_method"]);
               break;
            default:
               break;
        	}
        }
*/
// No longer needed 2.1.0 - These Custom Post Types have been removed
/*        public function mm_post_type_custom_columns($column){
          global $post, $woocommerce;

          switch ($column) {
            case 'mm_indirect_tax_type_title':
              $custom = get_post_custom();
              echo get_the_title($custom['mm_indirect_tax_type'][0]);
              break;
            case 'mm_indirect_tax_state':
              $custom = get_post_custom();
              echo $custom['mm_indirect_tax_state'][0];      
              break;
            case 'mm_indirect_tax_rate':
              $custom = get_post_custom();
              $method = $custom['mm_indirect_tax_calc_method'][0];
              if ($method == '1' || $method =='10'){
              	  $indirect_tax_rate = number_format($custom['mm_indirect_tax_rate'][0],3) . ' %';
              }
              else {
              	  $indirect_tax_rate = number_format($custom['mm_indirect_tax_rate'][0],4);
              }
              echo $indirect_tax_rate;      
              break;
            case 'mm_indirect_tax_calc_method':
              $custom = get_post_custom();
              switch ($custom['mm_indirect_tax_calc_method'][0]){
              	case '1':
              	   echo 'Percent of Cost';
                  break;
              	case '2':
              	   echo 'Flat Rate';
                  break;
              	case '3':
              	   echo 'Net Weight';
                  break;
              	case '4':
              	   echo 'Unit 1 Basis';
                  break;
              	case '5':
              	   echo 'Unit 2 Basis';
                  break;
              	case '6':
              	   echo 'Unit 3 Basis';
                  break;
              	case '10':
              	   echo 'Percent of Price';
                  break;
               default:
                  break;
              }
              break;
              case 'mm_custom_price_cust_id':
              $custom = get_post_custom();
              $user_id = $custom['user_id'][0];
              $cust_id = get_user_meta($user_id,'mm_field_CID',true) ;
              $first_name = get_user_meta($user_id,'billing_first_name',true) ;
              $last_name = get_user_meta($user_id,'billing_last_name',true) ;
              echo $cust_id . ' - ' . $first_name. ' '. $last_name;
              break;
            case 'mm_custom_price_sku':
              $custom = get_post_custom();
              $product_id = $custom['product_id'][0];
              $woo_product = wc_get_product( $product_id );
              if($woo_product != FALSE){
                 echo $woo_product->get_sku() ;
              }
              break;
            case 'mm_custom_price_product_name':
              $custom = get_post_custom();
              $product_id = $custom['product_id'][0];
              $woo_product = wc_get_product( $product_id );
              if($woo_product != FALSE){
                 echo $woo_product->get_name() ;      
              }
              break;
            case 'mm_custom_price_method':
              $custom = get_post_custom();
              $method_description = array('','Fixed Price','Discount Percent','Markup over Last Cost','Markup over Average Cost','Fixed amount over Last Cost',
                                          'Fixed amount over Average Cost','Price Level 1','Price Level 2','Price Level 3','Price Level 4','Price Level 5',
                                          'Price Level 6','Price Level 7','Price Level 8'); //note mm values are 1-based
              $method = $custom['method'][0];
              echo $method_description[$method];      
              break;
            case 'mm_custom_price_amount':
              $custom = get_post_custom();
              $method = $custom['method'][0];
              if ($method >= 2 && $method <=5 ){
                 $amount = number_format($custom['amount'][0],2) . ' %';
              }
              else {
              	  $amount = number_format($custom['amount'][0],2);
              }
              
              echo $amount;      
              break;

            case 'mm_custom_price_dates':
              $custom = get_post_custom();
              $start_date = $custom['start_date'][0];
              $end_date = $custom['end_date'][0];
              $formatted_start_date = ($start_date == '') ? '' : date_format(date_create_from_format('Ymd',$start_date),'m/d/Y') ;
              $formatted_end_date = ($end_date == '') ? '' : date_format(date_create_from_format('Ymd',$end_date),'m/d/Y') ;
              
              if ($start_date != '' && $end_date != ''){
                 echo $formatted_start_date . ' - ' . $formatted_start_date ;
              }
              elseif ($start_date != '') {
              	  echo  'Starting ' . $formatted_start_date ; 
              }
              elseif ($end_date != ''){
              	  echo  'Ending ' . $formatted_end_date ; 
              }

              
            
          }
        }
*/

//Indirect Taxes Removed 2.1.0
/*        public function mm_indirect_tax_edit_columns($columns){
          $columns = array(
            'cb' => '<input type="checkbox" />',
            'title' => 'Title',
            'mm_indirect_tax_type_title' => 'Indirect Tax Type',
            'mm_indirect_tax_state' => 'Tax State',
            'mm_indirect_tax_rate' => 'Tax Rate',
            'mm_indirect_tax_calc_method' => 'Calculation Method',
          );

          return $columns;
        }
*/
//Custom Prices Removed 2.0.0
/*        public function mm_customer_price_edit_columns($columns){
          $columns = array(
            'cb' => '<input type="checkbox" />',
            'mm_custom_price_cust_id' => 'Customer',
            'mm_custom_price_sku' => 'SKU',
            'mm_custom_price_product_name' => 'Product Name',
            'mm_custom_price_method' => 'Price Method',
            'mm_custom_price_amount' => 'Amount',
            'mm_custom_price_dates' => 'Date Range',
          );

          return $columns;
        }
*/



        /**
         * Execute model.
         *
         * @since 1.0.0
         * @access public
         */
        public function run() {

          add_action( 'init', array($this, 'mm_post_type_init' ));
          //add_action('admin_init', array($this, 'mm_post_type_admin_init'));
          //add_action('save_post', array($this, 'mm_post_type_save_details'));
          //add_action('manage_posts_custom_column',  array($this, 'mm_post_type_custom_columns'));
          //add_filter('manage_edit-mm-indirect-tax_columns', array($this, 'mm_indirect_tax_edit_columns'));
          //add_filter('manage_edit-mm-customer-price_columns', array($this, 'mm_customer_price_edit_columns'));

        }




     }
}
   